provider "kubernetes" {
  config_path = "~/.kube/config"
  config_context = "{{ kubeinstaller.context }}"
}

terraform {
  backend "kubernetes" {
    secret_suffix = "terraform-state-secret"
    config_path = "~/.kube/config"
    config_context = "{{ kubeinstaller.context }}"
    namespace = "{{ component.namespace }}"
  }
}

{%- for volume in kubeinstaller.sys.storage.volumes %}


resource "kubernetes_persistent_volume" "{{ volume.name | replace('.', '--') }}" {
  metadata {
    name = "{{ volume.name }}"
  }

  spec {
    capacity = {
      storage = "{{ volume.size }}"
    }

    claim_ref {
      namespace = "{{ volume.claim.namespace }}"
      name = "{{ volume.claim.name }}"
    }

    volume_mode = "Filesystem"

    access_modes = [
      "ReadWriteOnce"
    ]

    persistent_volume_reclaim_policy = "Retain"

    node_affinity {
      required {
        node_selector_term {
          match_expressions {
            key = "kubernetes.io/hostname"
            operator = "In"
            values = [
              "{{ volume.hostname }}"
            ]
          }
        }
      }
    }

    persistent_volume_source {
      local {
        path = "{{ volume.path }}"
      }
    }
  }
}

resource "kubernetes_persistent_volume_claim" "{{ volume.claim.namespace }}--{{ volume.claim.name }}" {
  metadata {
    namespace = "{{ volume.claim.namespace }}"
    name = "{{ volume.claim.name }}"
  }

  spec {
    access_modes = [
      "ReadWriteMany"
    ]

    resources {
      requests = {
        storage = "1Gi"
      }
    }

    volume_name = "{{ volume.name }}"
  }
}
{%- endfor %}
